/*
 * BME680.cpp
 *
 *  Created on: Jan. 20, 2022
 *      Author: Jimit_Patel
 *
 *      library is adapted from Adafruit_BME680
 */

#include <BME.h>
#include <stdint.h>
#include <Math.h>
#include "rtcdriver.h"
#include "sl_i2cspm_instances.h"





int64_t get_timestamp_us()
    {
  uint64_t t = RTCDRV_GetWallClockTicks64();   //once initialize , it expires in 12.5 days
  return RTCDRV_TicksToMsec(t)*1000;
    }


int8_t bus_read(uint8_t dev_addr, uint8_t targetAddress,uint8_t *rxBuff, uint16_t numBytes)
{
    I2C_TransferSeq_TypeDef i2cTransfer;
    I2C_TransferReturn_TypeDef result;

    // Initialize I2C transfer
    i2cTransfer.addr          = dev_addr;
    i2cTransfer.flags         = I2C_FLAG_WRITE_READ; // must write target address before reading
    i2cTransfer.buf[0].data   = &targetAddress;
    i2cTransfer.buf[0].len    = 1;
    i2cTransfer.buf[1].data   = rxBuff;
    i2cTransfer.buf[1].len    = numBytes;

    result = I2C_TransferInit(I2C0, &i2cTransfer);

    // Send data
    while (result == i2cTransferInProgress) {
      result = I2C_Transfer(I2C0);
    }

    if (result == i2cTransferDone)
             {
       // LED1 ON and infinite while loop to indicate I2C transmission problem
              return 0;
             }
         else{
             printf("i2c_write_fail");
             return 1;
             }
  }

int8_t bus_write(uint8_t dev_addr, uint8_t targetAddress,uint8_t *txBuff, uint16_t numBytes)
{
  I2C_TransferSeq_TypeDef i2cTransfer;
  I2C_TransferReturn_TypeDef result;
  uint8_t txBuffer[I2C_TXBUFFER_SIZE + 1];

  txBuffer[0] = targetAddress;
  for(int i = 0; i < numBytes; i++)
  {
      txBuffer[i + 1] = txBuff[i];
  }

  // Initialize I2C transfer
  i2cTransfer.addr          = dev_addr;
  i2cTransfer.flags         = I2C_FLAG_WRITE;
  i2cTransfer.buf[0].data   = txBuffer;
  i2cTransfer.buf[0].len    = numBytes + 1;
  i2cTransfer.buf[1].data   = NULL;
  i2cTransfer.buf[1].len    = 0;

  result = I2C_TransferInit(I2C0, &i2cTransfer);

  // Send data
  while (result == i2cTransferInProgress) {
    result = I2C_Transfer(I2C0);
  }

  if (result == i2cTransferDone)
          {
    // LED1 ON and infinite while loop to indicate I2C transmission problem
           return 0;
          }
      else{
          printf("i2c_write_fail");
          //while(1);
          return 1;
          }
}

  void sleep(uint32_t t_ms)
  {
    USTIMER_Delay(t_ms);
  }

  void output_ready(int64_t timestamp, float iaq, uint8_t iaq_accuracy, float temperature, float humidity,
          float pressure, float raw_temperature, float raw_humidity, float gas, bsec_library_return_t bsec_status,
          float static_iaq, float co2_equivalent, float breath_voc_equivalent)
  {
       printf("iaq = %d \n\r",(int)iaq);
       printf("iaq accuracy = %d \n\r",iaq_accuracy);
       printf("temperature = %d \n\r",(int)temperature);
       printf("humidity = %d \n\r",(int)humidity);
       printf("pressure = %d \n\r",(int)pressure);
       printf("static_iaq = %d \n\r",(int)raw_temperature);
       printf("static_iaq = %d \n\r",(int)raw_humidity);
       printf("static_iaq = %d \n\r",(int)gas);
       printf("static_iaq = %d \n\r",(int)static_iaq);
       printf("CO2 = %d \n\r",(int)co2_equivalent);
       printf("breath = %d \n\r",(int)breath_voc_equivalent);
  }
  uint32_t state_load(uint8_t * state_buffer, uint32_t n_buffer){

      return(0);
  }
  void state_save(const uint8_t * state_buffer, uint32_t length)
  {


  }
  uint32_t config_load(uint8_t *config_buffer, uint32_t n_buffer)
  {

        return(0);
    }

