/***************************************************************************//**
 * @file
 * @brief Top level application functions
 *******************************************************************************
 * # License
 * <b>Copyright 2020 Silicon Laboratories Inc. www.silabs.com</b>
 *******************************************************************************
 *
 * The licensor of this software is Silicon Laboratories Inc. Your use of this
 * software is governed by the terms of Silicon Labs Master Software License
 * Agreement (MSLA) available at
 * www.silabs.com/about-us/legal/master-software-license-agreement. This
 * software is distributed to you in Source Code format and is governed by the
 * sections of the MSLA applicable to Source Code.
 *
 ******************************************************************************/
#include "BME.h"
#include "retargetswo.h"
#include "em_gpio.h"
#include "bsec_serialized_configurations_iaq.h"


/***************************************************************************//**
 * Initialize application.
 ******************************************************************************/
void app_init(void)
{
  //CMU_ClockEnable(cmuClock_GPIO, true);

   RETARGET_SwoInit();
   sl_i2cspm_init_instances();
   RTCDRV_Init();
   USTIMER_Init();

}

/***************************************************************************//**
 * App ticking function.
 ******************************************************************************/
void app_process_action(void)
{

  return_values_init myRet;


  myRet = bsec_iot_init(BSEC_SAMPLE_RATE_LP, 0.0f, bus_write, bus_read, sleep, state_load, config_load);
      if(myRet.bme680_status != 0){
          printf("Could not initialize BME680 \n\r");
         // return (int)myRet.bme680_status;
      }
      else if(myRet.bsec_status){
          printf("Could not initialize BSEC \n\r");
         // return (int)myRet.bsec_status;
      }
      if((myRet.bme680_status == 0) && (myRet.bsec_status == 0))
        {
          printf("intialize BSEC library successful\r\n");
          /* Call to endless loop function which reads and processes data based on sensor settings */
          /* State is saved every 10.000 samples, which means every 10.000 * 3 secs = 500 minutes  */
          bsec_iot_loop(sleep, get_timestamp_us, output_ready, state_save, 10000);
        }


     
}
 
